/*###########################################################################
# QVGA(240~320)                                                            #
#          	LCDW[uEGO028Q02v8bit 䃂W[					#
#                                                     ILI9325               #
# AVR̃C^[tF[Xp CS=A15 / RS = A13							#
# LEDPB7Ő(Lowœ_/Hiŏ) timer0PWMɎgp					#
#																			#
# QljdqH̎                                                    #
#       http://www.picfun.com/                                              #
#       QVGATCYJ[TFTt\̕\                             #
#       http://www.picfun.com/app24Fframe.html                              #
#                                                                           #
###########################################################################*/
#ifndef __EGO028Q02_H__
#define __EGO028Q02_H__

#include <avr/io.h>
#include <avr/pgmspace.h>

#define USE_GRAPHIC 0				/* ჌xOtBbN֐LE	*/

/* `bvZbg}NiύXj		*/
#define LCD_ENABLE_RESET()	( PORTB &= ~_BV(PB6) )
#define LCD_DISABLE_RESET()	( PORTB |=  _BV(PB6) )

/* CfbNXWX^}bsOiύXj	*/
#define LCD_INDEX (*(volatile uint8_t *)0x4000)

/* f[^WX^}bsOiύXj		*/
#define LCD_DATA  (*(volatile uint8_t *)0x6000)

/* _`									*/
#define __LCD_POSITION_UP__		0x1010	/* ACR㑤ɂꍇA_ɂ	*/
#define __LCD_POSITION_DOWN__	0x1020	/* ACRɂꍇA_ɂ	*/
#define __LCD_POSITION_LEFT__	0x1008	/* ACRɂꍇA_ɂ	*/
#define __LCD_POSITION_RIGHT__	0x1038	/* ACREɂꍇA_ɂ	*/

/* _ݒiύXj						*/
//#define LCD_ZERO_POSITION __LCD_POSITION_UP__
//#define LCD_ZERO_POSITION __LCD_POSITION_DOWN__
//#define LCD_ZERO_POSITION __LCD_POSITION_LEFT__
#define LCD_ZERO_POSITION __LCD_POSITION_RIGHT__

/* ʃTCY`							*/
#if ( LCD_ZERO_POSITION == __LCD_POSITION_UP__ )
	#define DISPLAY_WIDTH 240
	#define DISPLAY_HEIGHT 320

#elif( LCD_ZERO_POSITION == __LCD_POSITION_DOWN__ )
	#define DISPLAY_WIDTH 240
	#define DISPLAY_HEIGHT 320

#elif( LCD_ZERO_POSITION == __LCD_POSITION_LEFT__ )
	#define DISPLAY_WIDTH 320
	#define DISPLAY_HEIGHT 240

#elif( LCD_ZERO_POSITION == __LCD_POSITION_RIGHT__ )
	#define DISPLAY_WIDTH 320
	#define DISPLAY_HEIGHT 240
#else
	#error "unknown LCD_ZERO_POSITION"
#endif

/* LCDCfbNXo(16bit)				*/
#define LCD_WRITE_INDEX(a) { LCD_INDEX = (uint8_t)((a) >> 8); LCD_INDEX = (uint8_t)( (a) & 0x00ff ); }

/* LCDf[^o(16bit)						*/
#define LCD_WRITE_DATA(a) { LCD_DATA = (uint8_t)((a) >> 8); LCD_DATA = (uint8_t)( (a) & 0x00ff ); }

/* LCDCfbNXf[^o				*/
#define LCD_COMMAND( index ,data ) { LCD_WRITE_INDEX(index); LCD_WRITE_DATA(data); }

/* Fϊ}N (r 0`255 / g 0`255 / b 0`255 )@*/
#ifndef RGB
#define RGB(r,g,b) ( ( ( (uint16_t)(r) << 8 ) & 0xf800 ) | ( ( (uint16_t)(g) << 3 ) & 0x07e0 ) |( ( (uint16_t)(b) >> 3 ) & 0x001f ) )
#endif

/* W\					*/
typedef struct POINT_t {
	uint16_t x;
	uint16_t y;
} POINT;

/* `\					*/
typedef struct RECT_t {
	uint16_t x1;
	uint16_t y1;
	uint16_t x2;
	uint16_t y2;
} RECT;

/* ֐vg^Cv錾		*/
void lcdInit( void );
void lcdSetBrightness( uint8_t lv );
uint8_t lcdGetBrightness( void );
void lcdSetBgColor( uint16_t c );
uint16_t lcdGetBgColor( void );
void lcdClear( void );
void lcdPutc( uint16_t x ,uint16_t y ,char c ,uint16_t fontColor );
void lcdPuts( uint16_t x ,uint16_t y ,char *str ,uint16_t fontColor );
void lcdPuts_P( uint16_t x ,uint16_t y ,const prog_char *str ,uint16_t fontColor );
void lcdSetPoint( uint16_t x ,uint16_t y );
void lcdSetWindow( uint16_t x1 ,uint16_t y1 ,uint16_t x2 );
uint8_t lcdRectClip( uint16_t *x1 ,uint16_t *y1 ,uint16_t *x2 ,uint16_t *y2 );

#if USE_GRAPHIC
void lcdPset( uint16_t x ,uint16_t y ,uint16_t c );
void lcdBoxF( uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t c );
void lcdBox( uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t c );
void lcdLine( uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t c );
void lcdCircle( uint16_t x0, uint16_t y0, uint8_t r, uint16_t c );
#endif

#endif
