/*###########################################################################
#                                                                           #
#		SPIڑtbVuAT45DB161Dv䃂W[            		#
#				y[WTCY512oCgŒ			                        #
#				y[W4096(2MBytes)									#
#																			#
###########################################################################*/
#define __AT45DB161D_C__

#include <avr/io.h>
#include <util/delay.h>
#include "at45db161d.h"
#include "MYUTIL/spi_func.h"

/* R}h`						*/
#define STATUS_REGISTER_READ 0xd7
#define READ_MANUFACTURER_AND_DEVICE_ID 0x9f
#define PAGE_READ 0xd2

#define CONTINUOUS_READ_HIGH_FREQ 0x0b

#define BUFFER_1_READ 0xd4
#define BUFFER_2_READ 0xd6

#define BUFFER_1_WRITE 0x84
#define BUFFER_2_WRITE 0x87

#define BUFFER_1_TO_PAGE_WITH_ERASE 0x83
#define BUFFER_2_TO_PAGE_WITH_ERASE 0x86

#define TRANSFER_PAGE_TO_BUFFER_1 0x53
#define TRANSFER_PAGE_TO_BUFFER_2 0x55

#define COMPARE_PAGE_TO_BUFFER_1 0x60
#define COMPARE_PAGE_TO_BUFFER_2 0x61

/* EGCg}N					*/
#define WAIT_MS(t) { uint16_t i=(uint16_t)(t); while (i--) { _delay_ms(1); } }

/*****************************************************************************
*								ݒ
* Fvoid
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
uint8_t flashInit( void )
{
	uint8_t sts;

	/* n[hEGAZbg			*/
	FLASH_ENABLE_RESET();
	FLASH_DISABLE_CS();
	WAIT_MS( 1 );

	/* SPI|[g				*/
	spiInit();
	SPI_HI_SPEED();
	WAIT_MS( 1 );

	/* Zbg					*/
	FLASH_DISABLE_RESET();
	WAIT_MS( 1 );

	/* Xe[^X`FbN			*/
	sts = flashReadStatusRegister();
	if ( ( sts & 0x3e ) != FLASH_STS_DEVICE_DENSITY ) {	/* Œlsv?	*/
		return ( 1 );
	}

	/* y[WTCY512oCgݒ						*/
	/* x512oCgɐݒ肷ƌɖ߂Ȃ̂Œ	*/
	if ( ( sts & FLASH_STS_PAGE_SIZE ) != FLASH_STS_PAGE_SIZE ) {

		/* POWER OF 2 s(̃R}hŃy[WTCY512BytesɌŒ肳)	*/
		FLASH_ENABLE_CS();
		spiTransfer( 0x3d );
		spiTransfer( 0x2a );
		spiTransfer( 0x80 );
		spiTransfer( 0xa6 );
		FLASH_DISABLE_CS();

		/* `bvZbg			*/
		FLASH_ENABLE_RESET();
		FLASH_DISABLE_CS();
		WAIT_MS( 1 );
		FLASH_DISABLE_RESET();
		WAIT_MS( 1 );

		/* Xe[^X`FbN		*/
		sts = flashReadStatusRegister();
		if ( ( sts & FLASH_STS_PAGE_SIZE ) != FLASH_STS_PAGE_SIZE ) {
			return ( 2 );
		}
	}

	return ( 0 );
}

/****************************************************************************
*						tbVǂݍ
* Fuint32_t address tbṼAhX
*		void     *dat    f[^ǂݍݗ̈
*		uint16_t len     ǂݍ݃f[^oCg
* ߒlFvoid
****************************************************************************/
void flashRead( uint32_t address ,void *dat ,uint16_t len )
{
	/* y[Wԍ^ItZbglvZ			*/
	uint16_t page = (uint16_t)( address / 512L );
	uint16_t offset = (uint16_t)( address % 512L );

	/* ǂݍ݃C							*/
	flashContinuousArrayRead( page ,offset );
	flashReadBLOCK( dat ,len );
	FLASH_DISABLE_CS();
}

/*****************************************************************************
*						tbV֏
* Fuint32_t address tbṼAhX
*		void     *dat    ݃f[^
*		uint16_t len     ݃f[^oCg
* ߒlFuint8_t          0:OK !0:RyAG[
*
* ̊֐xĂяoтɃtbṼy[WB
*   1oCg݂̏ły[WtbVsB
* tbṼobt@Pgp
*****************************************************************************/
uint8_t flashWrite( uint32_t address ,void *dat ,uint16_t len )
{
	/* y[Wԍ^ItZbglvZ			*/
	uint16_t page = (uint16_t)( address / 512L );
	uint16_t offset = (uint16_t)( address % 512L );

	/* ŏ̃y[Wf[^obt@ɓ]	*/
	flashPageToBuffer( FLASH_BUFFER1 ,page );		/* y[W -> obt@	*/
	flashBufferWrite( FLASH_BUFFER1 ,offset );		/* obt@݈ʒu	*/

	/* ݃C								*/
	uint8_t *p = (uint8_t *)dat;
	while ( len-- ) {
		flashWriteBYTE( *p++ );
		offset++;

		/* obt@^ɂȂꍇ̏	*/
		if ( offset >= 512 ) {
			flashBufferToPage( FLASH_BUFFER1 ,page );
			if ( flashComparePageToBuffer( FLASH_BUFFER1 ,page ) != 0 ) {	/* RyA	*/
				return ( 1 );
			}
			offset = 0;
			flashBufferWrite( FLASH_BUFFER1 ,offset );	/* obt@݈ʒu	*/
			page++;
		}
	}

	/* ݂̃obt@tbVɓ]		*/
	if ( offset != 0 ) {
		flashBufferToPage( FLASH_BUFFER1 ,page );			/* obt@ -> y[W	*/
		if ( flashComparePageToBuffer( FLASH_BUFFER1 ,page ) != 0 ) {	/* RyA	*/
			return ( 2 );
		}
	}

	flashEndAndWait();
	return ( 0 );
}

/*****************************************************************************
*			Py[W(512oCgŒ)tbV֏
* Fuint16_t page y[Wԍ
*		void     *dat ݃f[^(512oCg)
* ߒlFuint8_t  0:OK !0:RyAG[
* tbṼobt@Pgp
*****************************************************************************/
uint8_t flashWritePage( uint16_t page ,void *dat )
{
	uint8_t *p = (uint8_t *)dat;
	uint8_t cnt = 128;

	/* obt@Pփf[^				*/
	flashBufferWrite( FLASH_BUFFER1 ,0 );
	while ( cnt-- ) {
		spiTransfer( *p++ );
		spiTransfer( *p++ );
		spiTransfer( *p++ );
		spiTransfer( *p++ );
	}
	FLASH_DISABLE_CS();

	/* obt@P̓etbṼy[W֓]		*/
	flashBufferToPage( FLASH_BUFFER1 ,page );

	/* RyA											*/	
	return ( flashComparePageToBuffer( FLASH_BUFFER1 ,page ) );
}

/*****************************************************************************
*			Py[W(512oCgŒ)tbVǂݍ
* Fuint16_t page y[Wԍ
*		void     *dat ǂݍ݃f[^̈(512oCg)
* ߒlFvoid
*****************************************************************************/
void flashReadPage( uint16_t page ,void *dat )
{
	uint8_t *p = (uint8_t *)dat;
	uint8_t cnt = 128;

	/* ǂݍ݃C							*/
	flashContinuousArrayRead( page ,0 );
	while ( cnt-- ) {
		*p++ = spiTransfer( 0xff );
		*p++ = spiTransfer( 0xff );
		*p++ = spiTransfer( 0xff );
		*p++ = spiTransfer( 0xff );
	}
	FLASH_DISABLE_CS();
}

/*****************************************************************************
*					tbVBYTEMs
* Fvoid
* ߒlFuint8_t Ml
*****************************************************************************/
uint8_t flashReadBYTE( void )
{
	return ( spiTransfer( 0xff ) );
}

/*****************************************************************************
*					tbVubNMs
* Fvoid     *dat ubN̈ւ̃|C^
*		uint16_t len  ǂݍ݃f[^
* ߒlFvoid
*****************************************************************************/
inline void flashReadBLOCK( void *dat ,uint16_t len )
{
	uint8_t *p = (uint8_t *)dat;
	while ( len-- ) {
		*p++ = spiTransfer( 0xff );
	}
}

/*****************************************************************************
*					tbVBYTEMs
* Fuint8_t dat Ml
* ߒlFvoid
*****************************************************************************/
void flashWriteBYTE( uint8_t dat )
{
	spiTransfer( dat );
}

/*****************************************************************************
*					tbVփubNMs
* Fvoid     *dat ubN̈ւ̃|C^
*		uint16_t len  Mf[^
* ߒlFvoid
*****************************************************************************/
void flashWriteBLOCK( void *dat ,uint16_t len )
{
	uint8_t *p = (uint8_t *)dat;
	while ( len-- ) {
		spiTransfer( *p++ );
	}
}

/*****************************************************************************
*							Xe[^XWX^擾
* Fvoid
* ߒlFuint8_t Xe[^X
*****************************************************************************/
uint8_t flashReadStatusRegister( void )
{
	FLASH_DISABLE_CS();
	FLASH_ENABLE_CS();
	spiTransfer( STATUS_REGISTER_READ );
	uint8_t status = spiTransfer( 0x00 );
	FLASH_DISABLE_CS();

	return ( status );
}

/*****************************************************************************
*						[huManufacturer And Device IDv
* FFLSAH_MANUFACTUER_ID *id ǂݍݐ̍\̂ւ̃|C^
* ߒlFvoid
*****************************************************************************/
void flashReadManufacturerAndDeviceID( FLSAH_MANUFACTUER_ID *id )
{
	FLASH_DISABLE_CS();
	FLASH_ENABLE_CS();
	spiTransfer( READ_MANUFACTURER_AND_DEVICE_ID );
	id->manufacturer = spiTransfer( 0xff );			/* Manufacturer ID		*/
	id->device[0] = spiTransfer( 0xff );			/* Device ID (part 1)	*/
	id->device[1] = spiTransfer( 0xff );			/* Device ID (part 2)	*/
	id->extendedInfoLength = spiTransfer( 0xff );	/* Extended Device Information String Length */
	FLASH_DISABLE_CS();
}

/*****************************************************************************
*				Cy[Wւ̃[h|C^ݒ
* Fuint16_t page   y[Wԍ    0 ` 4095
*		uint16_t offset ItZbgl  0 ` 511
* ߒlFvoid
*****************************************************************************/
void flashContinuousArrayRead( uint16_t page, uint16_t offset )
{
	FLASH_DISABLE_CS();
	FLASH_ENABLE_CS();
	spiTransfer( CONTINUOUS_READ_HIGH_FREQ );
	spiTransfer( (uint8_t)( page >> 7 ) );
	spiTransfer( (uint8_t)( ( page << 1 ) | ( offset >> 8 ) ) );
	spiTransfer( (uint8_t)offset );
	spiTransfer( 0x00 );
}

/*****************************************************************************
*						obt@ւ̃[h|C^ݒ
* Fuint8_t  bufferNum obt@ԍ@FLASH_BUFFER1 or FLASH_BUFFER2
*		uint16_t offset    ItZbgl  0 ` 511
* ߒlFvoid
*****************************************************************************/
void flashBufferRead( uint8_t bufferNum ,uint16_t offset )
{
	FLASH_DISABLE_CS();
	FLASH_ENABLE_CS();
	spiTransfer( ( bufferNum == FLASH_BUFFER1 ) ? BUFFER_1_READ : BUFFER_2_READ );
	spiTransfer( 0x00 );
	spiTransfer( (uint8_t)( offset >> 8 ) );
	spiTransfer( (uint8_t)offset);
	spiTransfer( 0x00 );
}

/*****************************************************************************
*						obt@ւ̃Cg|C^ݒ
* Fuint8_t  bufferNum obt@ԍ@FLASH_BUFFER1 or FLASH_BUFFER2
*		uint16_t offset    ItZbgl  0 ` 511
* ߒlFvoid
*****************************************************************************/
void flashBufferWrite( uint8_t bufferNum ,uint16_t offset )
{
	FLASH_DISABLE_CS();
	FLASH_ENABLE_CS();
	spiTransfer( ( bufferNum == FLASH_BUFFER1 ) ? BUFFER_1_WRITE : BUFFER_2_WRITE );
	spiTransfer( 0x00 );
	spiTransfer( (uint8_t)( offset >> 8 ) );
	spiTransfer( (uint8_t)offset );
}

/*****************************************************************************
*					obt@Cy[W֓]
* Fuint8_t  bufferNum obt@ԍ@FLASH_BUFFER1 or FLASH_BUFFER2
*		uint16_t page      y[Wԍ    0 ` 4095
* ߒlFvoid
*****************************************************************************/
void flashBufferToPage( uint8_t bufferNum ,uint16_t page )
{
	FLASH_DISABLE_CS();
	FLASH_ENABLE_CS();
	spiTransfer( ( bufferNum == FLASH_BUFFER1 ) ? BUFFER_1_TO_PAGE_WITH_ERASE : BUFFER_2_TO_PAGE_WITH_ERASE );
	spiTransfer( (uint8_t)( page >> 7 ) );
	spiTransfer( (uint8_t)( page << 1 ) );
	spiTransfer( 0x00 );
	FLASH_DISABLE_CS();

	while ( !( flashReadStatusRegister() & FLASH_STS_READY_BUSY ) );
}

/*****************************************************************************
*					Cy[Wobt@֓]
* Fuint8_t  bufferNum obt@ԍ@FLASH_BUFFER1 or FLASH_BUFFER2
*		uint16_t page      y[Wԍ    0 ` 4095
* ߒlFvoid
*****************************************************************************/
void flashPageToBuffer( uint8_t bufferNum ,uint16_t page )
{
	FLASH_DISABLE_CS();
	FLASH_ENABLE_CS();
	spiTransfer( ( bufferNum == FLASH_BUFFER1 ) ? TRANSFER_PAGE_TO_BUFFER_1 : TRANSFER_PAGE_TO_BUFFER_2 );
	spiTransfer( (uint8_t)( page >> 7 ) );
	spiTransfer( (uint8_t)( page << 1 ) );
	spiTransfer( 0x00 );
	FLASH_DISABLE_CS();

	while ( !( flashReadStatusRegister() & FLASH_STS_READY_BUSY ) );
}

/*****************************************************************************
*									]I
* Fvoid
* ߒlFvoid
*****************************************************************************/
void flashEndAndWait( void )
{
	FLASH_DISABLE_CS();
	while ( !( flashReadStatusRegister() & FLASH_STS_READY_BUSY ) );
}

/*****************************************************************************
*					Cƃobt@r
* Fuint8_t  bufferNum obt@ԍ@FLASH_BUFFER1 or FLASH_BUFFER2
*		uint16_t page      y[Wԍ    0 ` 4095
* ߒlFuint8_t  0:v  !0:sv
*****************************************************************************/
uint8_t flashComparePageToBuffer( uint8_t bufferNum ,uint16_t page )
{
	uint8_t sts;

	FLASH_DISABLE_CS();
	FLASH_ENABLE_CS();
	spiTransfer( ( bufferNum == FLASH_BUFFER1 ) ? COMPARE_PAGE_TO_BUFFER_1 : COMPARE_PAGE_TO_BUFFER_2 );
	spiTransfer( (uint8_t)( page >> 7 ) );
	spiTransfer( (uint8_t)( page << 1 ) );
	spiTransfer( 0x00 );
	FLASH_DISABLE_CS();

  	do {
		sts = flashReadStatusRegister();
	} while ( !( sts & FLASH_STS_READY_BUSY ) );

  	return ( sts & FLASH_STS_COMPARE );
}

