/*###########################################################################
#                                                                           #
#						FONTX ֐Q									#
#                                                                           #
###########################################################################*/
#define __FONTS_C__
#include "project.h"

/* [Jϐ錾				*/
static FONT_SET fontSets[FONT_COUNT_MAX];
static uint8_t installFonts = 0;

#if FONT_ENTRY_MEMORY
typedef struct ENTRY_t {
	uint16_t st;
	uint16_t ed;
} ENTRY;
static ENTRY *entry[FONT_COUNT_MAX];
static uint16_t memory = 0;
#endif

/*****************************************************************************
*							tHg
* Fvoid
* ߒlFuint8_t 0:OK / !0:s
*****************************************************************************/
uint8_t font_init( void )
{
	uint16_t i;
	uint16_t fsIndex;
	FONT *font;

	memset( &fontSets ,0x00 ,sizeof(fontSets) );
	installFonts = 0;

#if FONT_ENTRY_MEMORY
	memory = 0;
#endif
	
	for ( i = 0 ;i < FONT_COUNT_MAX ;i++ ) {
		fsIndex = FL_FONT_START + ( i * 2 );

		/* ptHgf[^擾	*/
		font = &fontSets[i].hFont;
		if ( font_getInfo( fsIndex + 0 ,font ) != 0 ) {
			break;
		}

		/* SptHgf[^擾	*/
		font = &fontSets[i].zFont;
		if ( font_getInfo( fsIndex + 1 ,font ) != 0 ) {
			break;
		}

		/* Gg[f[^擾		*/
#if FONT_ENTRY_MEMORY
		uint16_t entrySize = (uint16_t)font->tnum * sizeof(ENTRY);
		entry[i] = malloc( entrySize );
		if ( entry[i] == NULL ) {
			return ( 1 );
		}
		memset( entry[i] ,0x00 ,entrySize );
		flashContinuousArrayRead( font->entPage ,font->entOffset );
		flashReadBLOCK( entry[i] ,entrySize );
		flashEndAndWait();
		memory += entrySize;
#endif
	}

	installFonts = i;
	return ( 0 );
}

/*****************************************************************************
*					CXg[ĂtHg擾
* Fvoid
* ߒlFuint8_t
*****************************************************************************/
uint8_t font_count( void )
{
	return ( installFonts );
}

/*****************************************************************************
*			CXg[ĂGg[e[uTCY擾
* Fvoid
* ߒlFuint16_t
*****************************************************************************/
uint16_t font_entrySize( void )
{
#if FONT_ENTRY_MEMORY
	return ( memory + sizeof(memory) + sizeof(entry) );
#else
	return ( 0 );
#endif
}

/*****************************************************************************
*					wR[htHgC[Wf[^擾
* Fuint8_t   fontIndex  tHgԍ(1`)
*		uint16_t  code       R[h( ASCII / S-JIS )
*		uint8_t   *img       C[Wf[^i[̈( FONT_DATA_MAX_LENGTH )
* ߒlFFONT *               擾tHg
*****************************************************************************/
FONT *font_getImage( uint8_t fontIndex ,uint16_t code ,uint8_t *img )
{
	uint32_t addr;
	uint16_t i;
	FONT *font = NULL;
	FONT_SET *fontSet;
	uint16_t index = 0;

#if FONT_ENTRY_MEMORY
	ENTRY *e;
#else
	struct {
		uint16_t st;
		uint16_t ed;
	} inf;
#endif

	if ( ( fontIndex >= 1 ) || ( fontIndex > installFonts ) ) {
		fontIndex--;
		fontSet = &fontSets[ fontIndex ];

		/* S-JISR[h̏ꍇ̃tHgf[^擾	*/
		if ( code & 0xff00 ) {
			font = &fontSet->zFont;

			/* Gg[e[uR[h	*/
#if FONT_ENTRY_MEMORY
			e = entry[ fontIndex ];
			i = font->tnum;
			while ( i-- ) {
				if ( ( e->st <= code ) && ( e->ed >= code ) ) {
					index += ( code - e->st );
					break;
				}
				index += ( ( e->ed - e->st ) + 1 );
				e++;
			}
#else
			flashContinuousArrayRead( font->entPage ,font->entOffset );
			for ( i = 0 ;i < font->tnum ;i++ ) {
				flashReadBLOCK( &inf ,4 );
				if ( ( inf.st <= code ) && ( inf.ed >= code ) ) {
					index += ( code - inf.st );
					break;
				}
				index += ( ( inf.ed - inf.st ) + 1 );
			}
			flashEndAndWait();
#endif

			if ( i < font->tnum ) {		/* Gg[ĂR[hH		*/
				code = index;
			} else {					/* Gg[ĂȂR[hH	*/
				font = &fontSet->hFont;
				code = 0x20;
			}

		/* ASCIIR[h̏ꍇ̃tHgf[^擾	*/
		} else {
			font = &fontSet->hFont;
		}

		/* tHgf[^VAtbV擾	*/
		if ( img != NULL ) {
			addr = font->dataTop + ( (uint32_t)code * (uint32_t)font->charPerBytes );
			flashRead( addr ,img ,font->charPerBytes );
		}
	}

	return ( font );
}

/*****************************************************************************
*	VAtbVɊi[Ă FONTX2 `̃t@C擾
* Fuint16_t index FlashFsCfbNXԍ
*       FONT     *fnt  tHgi[̈
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
uint8_t font_getInfo( uint16_t index ,FONT *fnt )
{
	FLASH_FS_INFO inf;
	uint32_t base;
	char buf[18];

	memset( fnt ,0x00 ,sizeof(FONT) );

	/* t@C擾					*/
	flashFs_readIndex( index ,&inf );
	if ( inf.fname[0] == 0x00 ) {
		return ( 1 );
	}

	/* 擪f[^擾(18bytes)			*/
	base = inf.topPage * 512L;
	flashRead( base ,buf ,18 );

	/* "FONTX2"ʎqmF				*/
	if ( memcmp_P( &buf[0] ,PSTR("FONTX2") ,6 ) != 0 ) {
		return ( 2 );
	}

	/* TCY擾						*/
	fnt->xsize = buf[14];
	if ( fnt->xsize > FONT_WIDTH_MAX ) {
		return ( 3 );
	}
	/* cTCY擾						*/
	fnt->ysize = buf[15];
	if ( fnt->ysize > FONT_HEIGHT_MAX ) {
		return ( 4 );
	}

	/* R[h^Cv擾					*/
	fnt->codeType = buf[16];
	if ( ( fnt->codeType != 0 ) && ( fnt->codeType != 1 ) ) {
		return ( 5 );
	}

	/* 1C̃oCgvZ			*/
	fnt->linePerBytes = ( fnt->xsize + 7 ) / 8;

	/* 1̃oCgvZ				*/
	fnt->charPerBytes = fnt->ysize * fnt->linePerBytes;

	if ( fnt->codeType == 1 ) {

		/* Gg[擾				*/
		fnt->tnum = buf[17];

		/* Gg[̐擪ʒu			*/
		fnt->entPage = ( base + 18L ) / 512L;
		fnt->entOffset = ( base + 18L ) % 512L;

		/* tHgf[^擪ʒuvZ	*/
		fnt->dataTop = base + 18L + ( (uint32_t)fnt->tnum * 4L );

	} else {
		fnt->dataTop = base + 17L;
	}

	return ( 0 );
}
