/*###########################################################################
#                                                                           #
#  			             OtBbNCu								#
#                                                                           #
###########################################################################*/
#define __GRAPHIC_C__
#include "project.h"
#include "MYUTIL/timer.h"

/* [Jϐ								*/
static G_BGMODE bgMode = G_BGMODE_COLOR;	/* wi[h					*/
static uint16_t bgColor = 0;				/* wiF						*/
static FLASH_FS_INFO bgInfo;				/* wi摜					*/
static uint8_t brightness = 255;			/* obNCgPx				*/
static uint8_t g_bgCount = 0;				/* wi摜ێ				*/
static uint16_t g_imageCount = 0;			/* C[W摜ێ			*/
static uint8_t g_sw = 0;					/* \^\					*/

/* [J֐vg^Cv錾				*/
static uint8_t g_puts_sub( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,uint16_t xclip ,uint8_t xposOffset ,char *str ,uint16_t fColor ,uint16_t bColor );

/*****************************************************************************
*							ݒ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_init( void )
{
	g_sw = g_imageCount = g_bgCount = 0;
	lcdInit();
	g_cls();
	g_on();
}

/*****************************************************************************
*							BG / IMAGE ݒ
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_images_init( void )
{
	uint16_t i;
	FLASH_FS_INFO inf;

	g_imageCount = g_bgCount = 0;
	
	for ( i = 0 ;i < BG_MAX ;i++ ) {
		flashFs_readIndex( FL_BG_START + i ,&inf );
		if ( ( inf.ftype != FLASH_FS_IMAGE ) || ( inf.width != DISPLAY_WIDTH ) || ( inf.height != DISPLAY_HEIGHT ) ) {
			break;
		}
		g_bgCount++;
	}

	for ( i = 0 ;i < IMAGE_MAX ;i++ ) {
		flashFs_readIndex( FL_IMG_START + i ,&inf );
		if ( inf.ftype != FLASH_FS_IMAGE ) {
			break;
		}
		g_imageCount++;
	}
}

/*****************************************************************************
*							ʕ\OFF
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_off( void )
{
	g_sw = 0;
	lcdSetBrightness( 0 );
}

/*****************************************************************************
*							ʕ\ON
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_on( void )
{
	g_sw = 0;
	lcdSetBrightness( brightness );
}
/*****************************************************************************
*							ʋPxύX
* Fuint8_t lv 0     :obNCgOFF
*				   1`254:PWM(傫邢)
*				   255   :obNCgON(펞_)
* ߒlFvoid
*****************************************************************************/
void g_setBrightness( uint8_t lv )
{
	if ( g_sw ) {
		lcdSetBrightness( lv );
	}
	brightness = lv;
}

/*****************************************************************************
*							wiύX
* FG_BGMODE mode  wi[h G_BGMODE_COLOR : PF[h
*                                 G_BGMODE_IMAGE : ǎ[h
*		uint16_t color mode = G_BGMODE_COLOR : wiF
*					   mode = G_BGMODE_IMAGE : wiԍ(1`)
* ߒlFuint8_t        0:OK !0:NG
*****************************************************************************/
uint8_t g_setBgColor( G_BGMODE mode ,uint16_t color )
{
	FLASH_FS_INFO imgInfo;
	uint8_t ret = 1;

	if ( mode == G_BGMODE_IMAGE ) {
		if ( color && ( color <= g_bgCount ) ) {
			flashFs_readIndex( color + FL_BG_START - 1 ,&imgInfo );
			if ( ( imgInfo.height == DISPLAY_HEIGHT ) && ( imgInfo.width == DISPLAY_WIDTH ) ) {
				memcpy( &bgInfo ,&imgInfo ,sizeof(bgInfo) );
				bgMode = mode;
				ret = 0;
			}
		}

	} else if ( mode == G_BGMODE_COLOR ) {
		bgColor = color;
		bgMode = mode;
		ret = 0;
	}

	g_cls();
	return ( ret );
}

/*****************************************************************************
*								ʃNA
* Fvoid
* ߒlFvoid
*****************************************************************************/
void g_cls( void )
{
	lcdSetWindow( 0 ,0 ,DISPLAY_WIDTH - 1 );
	
	if ( bgMode == G_BGMODE_COLOR ) {
		uint16_t n = 9600;
		while ( n-- ) {
			LCD_WRITE_DATA( bgColor );
			LCD_WRITE_DATA( bgColor );
			LCD_WRITE_DATA( bgColor );
			LCD_WRITE_DATA( bgColor );
			LCD_WRITE_DATA( bgColor );
			LCD_WRITE_DATA( bgColor );
			LCD_WRITE_DATA( bgColor );
			LCD_WRITE_DATA( bgColor );
		}
	} else {
		uint16_t x ,y;
		flashContinuousArrayRead( bgInfo.topPage ,0 );
		for ( y = 0; y < DISPLAY_HEIGHT ;y++ ) {
			for ( x = 0 ;x < DISPLAY_WIDTH ;x++ ) {
				LCD_DATA = flashReadBYTE();
				LCD_DATA = flashReadBYTE();
			}
		}
	}
}

/*****************************************************************************
*								hbg`
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*		uint16_t    x1    XW
*		uint16_t    y1    YW
*		uint16_t    color \F
* ߒlFvoid
*****************************************************************************/
void g_pset( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t color )
{
	uint32_t pos = 0;
	uint16_t page = 0;
	uint16_t offset = 0;
	uint8_t bc1 = 0 ,bc2 = 0;
	uint8_t ic1,ic2;
	uint8_t rgb[3];

	if ( ( x1 >= DISPLAY_WIDTH ) || ( y1 >= DISPLAY_HEIGHT ) ) {
		return;
	}

	/* OiFݒ				*/
	ic1 = (uint8_t)( color >> 8 );
	ic2 = (uint8_t)color;

	/* wiF擾				*/
	if  ( mode & 0x80 ) {							/* BGKv?		*/
		if ( bgMode == G_BGMODE_COLOR ) {			/* PF[h?		*/
			bc1 = (uint8_t)( bgColor >> 8 );
			bc2 = (uint8_t)bgColor;
		} else {
			pos = ( (uint32_t)y1 * (uint32_t)bgInfo.bytesPerLine ) + ( (uint32_t)x1 * 2L );
			page = bgInfo.topPage + (uint16_t)( pos / 512L );
			offset = (uint16_t)( pos % 512L );
			flashContinuousArrayRead( page ,offset );
			bc1 = flashReadBYTE();
			bc2 = flashReadBYTE();
		}
	}

	/* LCD\JnʒuZbg		*/
	lcdSetPoint( x1 ,y1 );

	/* `						*/
	if ( ( mode == G_HALF_ALL ) || ( mode == G_HALF ) ) {
		rgb[0] = ( ( ic1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
		rgb[1] = ( ( ( ( ic1 << 3 ) & 0x3f ) | ( ic2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
		rgb[2] = ( ( ic2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
		LCD_DATA = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
		LCD_DATA = ( ( rgb[1] << 5 ) | rgb[2] );

	/* ʏ`							*/
	} else {
		LCD_DATA = ic1;
		LCD_DATA = ic2;
	}
}

/*****************************************************************************
*								`
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*       uint16_t    x1    X1W( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y1    Y1W( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    x2    X2W( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y2    Y2W( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    color \F
* ߒlFvoid
*****************************************************************************/
void g_line( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color )
{
	uint16_t dx = 0 ,dy = 0;		/* (X1,X2) (Y2,Y1)̍Βl			*/
	uint16_t sx = 0 ,sy = 0;		/* X/YWړ 0:ړ 1: 2:E	*/
	uint16_t e = 0;					/* 덷									*/
	uint16_t i;						/* 厲WJE^						*/

	/* WNbsO				*/
	if ( x1 & 0x8000 ) {
		x1 = 0;
	} else if ( x1 >= DISPLAY_WIDTH ) {
		x1 = DISPLAY_WIDTH - 1;
	}

	if ( x2 & 0x8000 ) {
		x2 = 0;
	} else if ( x2 >= DISPLAY_WIDTH ) {
		x2 = DISPLAY_WIDTH - 1;
	}

	if ( y1 & 0x8000 ) {
		y1 = 0;
	} else if ( y1 >= DISPLAY_HEIGHT ) {
		y1 = DISPLAY_HEIGHT - 1;
	}

	if ( y2 & 0x8000 ) {
		y2 = 0;
	} else if ( y2 >= DISPLAY_HEIGHT ) {
		y2 = DISPLAY_HEIGHT - 1;
	}

	/* X1,X2̐ΒlXړvZ	*/
	if ( x1 > x2 ) {
		dx = x1 - x2;
		sx = 1;
	} else if ( x1 < x2 ) {
		dx = x2 - x1;
		sx = 2;
	}

	/* Y1,Y2̐ΒlYړvZ	*/
	if ( y1 > y2 ) {
		dy = y1 - y2;
		sy = 1;
	} else if ( y1 < y2 ) {
		dy = y2 - y1;
		sy = 2;
	}

	/* ̑傫厲Ƃ	*/
	if ( dx >= dy ) {
		for ( i = 0 ;i <= dx ;i++ ) {
			g_pset( mode ,x1 ,y1 ,color );
			e += dy;
			if ( e > dx ) {
				e -= dx;
				if ( sy == 1 ) {
					y1--;
				} else if ( sy == 2 ) {
					y1++;
				}
			}
			if ( sx == 1 ) {
				x1--;
			} else if ( sx == 2 ) {
				x1++;
			}
		}

	} else {
		for ( i = 0 ;i <= dy ;i++ ) {
			g_pset( mode ,x1 ,y1 ,color );
			e += dx;
			if ( e > dy ) {
				e -= dy;
				if ( sx == 1 ) {
					x1--;
				} else if ( sx == 2 ) {
					x1++;
				}
			}
			if ( sy == 1 ) {
				y1--;
			} else if ( sy == 2 ) {
				y1++;
			}
		}
	}
}

/*****************************************************************************
*								`\
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*       uint16_t    x1    \̈`XW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y1    \̈`YW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    x2    \̈`EXW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y2    \̈`EYW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    color \F
* ߒlFvoid
*****************************************************************************/
void g_box( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color )
{
	uint16_t i;

	/* WNbsO				*/
	if ( lcdRectClip( &x1 ,&y1 ,&x2 ,&y2 ) ) {
		return;
	}

	/* `惁C					*/
	for ( i = x1 ;i <= x2 ;i++ ) {
		g_pset( mode ,i ,y1 ,color );
		g_pset( mode ,i ,y2 ,color );
	}

	for ( i = y1 ;i <= y2 ;i++ ) {
		g_pset( mode ,x1 ,i ,color );
		g_pset( mode ,x2 ,i ,color );
	}
}

/*****************************************************************************
*						hԂ`\
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*       uint16_t    x1    \̈`XW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y1    \̈`YW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    x2    \̈`EXW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y2    \̈`EYW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint16_t    color \F
* ߒlFvoid
*****************************************************************************/
void g_boxF( G_DRAWMODE mode ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 ,uint16_t color )
{
	uint32_t pos = 0;
	uint16_t page = 0;
	uint16_t offset = 0;
	uint16_t x ,y;
	uint8_t bc1 = 0 ,bc2 = 0;
	uint8_t ic1,ic2;
	uint8_t bgGetFlag;
	uint8_t rgb[3];

	/* WNbsO				*/
	if ( lcdRectClip( &x1 ,&y1 ,&x2 ,&y2 ) ) {
		return;
	}

	/* OiFݒ				*/
	ic1 = (uint8_t)( color >> 8 );
	ic2 = (uint8_t)color;

	/* wiF擾				*/
	bgGetFlag = 0;
	if  ( mode & 0x80 ) {							/* BGKv?		*/
		if ( bgMode == G_BGMODE_COLOR ) {			/* PF[h?		*/
			bc1 = (uint8_t)( bgColor >> 8 );
			bc2 = (uint8_t)bgColor;
		} else {
			bgGetFlag = 1;
		}
	}

	/* LCD\JnʒuZbg		*/
	lcdSetWindow( x1 ,y1 ,x2 );

	/* BGC[WC擪vZ		*/
	if ( bgGetFlag ) {
		pos = ( (uint32_t)y1 * (uint32_t)bgInfo.bytesPerLine ) + ( (uint32_t)x1 * 2L );
		page = bgInfo.topPage + (uint16_t)( pos / 512L );
		offset = (uint16_t)( pos % 512L );
	}

	for ( y = y1 ;y <= y2 ;y++ ) {

		/* BGC[WCݒ		*/
		if ( bgGetFlag ) {
			flashContinuousArrayRead( page ,offset );
		}

		for ( x = x1 ;x <= x2 ;x++ ) {

			/* BGC[WsNZF擾			*/
			if ( bgGetFlag ) {
				bc1 = flashReadBYTE();
				bc2 = flashReadBYTE();
			}

			/* `						*/
			if ( ( mode == G_HALF_ALL ) || ( mode == G_HALF ) ) {
				rgb[0] = ( ( ic1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
				rgb[1] = ( ( ( ( ic1 << 3 ) & 0x3f ) | ( ic2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
				rgb[2] = ( ( ic2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
				LCD_DATA = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
				LCD_DATA = ( ( rgb[1] << 5 ) | rgb[2] );

			/* ʏ`							*/
			} else {
				LCD_DATA = ic1;
				LCD_DATA = ic2;
			}
		}

		/* BGC[WCXebv			*/
		if ( bgGetFlag ) {
			pos += (uint32_t)bgInfo.bytesPerLine;
			page = bgInfo.topPage + (uint16_t)( pos / 512L );
			offset = (uint16_t)( pos % 512L );
		}
	}
}

/*****************************************************************************
*									~`
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ʏ\
*                                    G_HALF_ALL    `
*                                    G_TRANSPARENT ʏ\
*                                    G_HALF        `
*       uint16_t    x0    SXW( 0 ` DISPLAY_WIDTH - 1 )
*		uint16_t    y0    SYW( 0 ` DISPLAY_HEIGHT - 1 )
*		uint8_t     r     a
*		uint16_t    color \F
* ߒlFvoid
*****************************************************************************/
void g_circle( G_DRAWMODE mode ,uint16_t x0, uint16_t y0, uint8_t r, uint16_t color )
{
	short x = (short)r;
	short y = 0;
	short F = -2 * (short)r + 3;

	while( x >= y ) {
		g_pset( mode ,x0 + x ,y0 + y ,color );
		g_pset( mode ,x0 - x ,y0 + y ,color );
		g_pset( mode ,x0 + x ,y0 - y ,color );
		g_pset( mode ,x0 - x ,y0 - y ,color );
		g_pset( mode ,x0 + y ,y0 + x ,color );
		g_pset( mode ,x0 - y ,y0 + x ,color );
		g_pset( mode ,x0 + y ,y0 - x ,color );
		g_pset( mode ,x0 - y ,y0 - x ,color );
		if ( F >= 0 ) {
			x--;
			F -= 4 * x;
		}
		y++;
		F += 4 * y + 2;
	}
}

/*****************************************************************************
*				SPItbVɊi[Ă摜\
* Fuint16_t    index 摜ԍ( 1 ` )
*		G_DRAWMODE  mode  `惂[h G_OPAQUE      C[Ŵ܂ܕ`
*                                    G_HALF_ALL    SsNZ𔼓`
*                                    G_TRANSPARENT wF𓧖ŕ` / ̑̐Fʏ`
*                                    G_HALF        wF𓧖ŕ` / ̑̐F𔼓`
*		uint16_t   color FL[( G_TRANSPARENT / G_HALF ̎ɋ@\ )
*		uint16_t      x1    \̈`XW
*		uint16_t      y1    \̈`YW
* 		uint16_t      x2    \̈`EXW
*		uint16_t t    y2    \̈`EYW
* ߒlFvoid
*****************************************************************************/
void g_image( uint16_t index ,G_DRAWMODE mode ,uint16_t color ,uint16_t x1 ,uint16_t y1 ,uint16_t x2 ,uint16_t y2 )
{
	uint32_t bgPos = 0L;
	uint16_t bgPage = 0;			/* wiBGC[WSPItbVʒu	*/
	uint16_t bgOffset = 0;

	uint32_t imgPos = 0L;
	uint16_t imgPage = 0;			/* \C[WSPItbVʒu		*/
	uint16_t imgOffset = 0;

	uint8_t bgImg[DISPLAY_WIDTH * 2];	/*wiBGC[WCf[^obt@*/
	uint8_t *bgp = bgImg;			/* bgImgւ̃|C^					*/

	FLASH_FS_INFO imgInfo;			/* C[Wt@C					*/

	uint8_t rgb[3];					/* rgbpobt@					*/
	uint8_t bgGetFlag;

	uint8_t bc1 = 0 ,bc2 = 0;		/* BGsNZF							*/
	uint8_t ic1 = 0 ,ic2 = 0;		/* \C[WsNZF				*/
	uint8_t kc1 = 0 ,kc2 = 0;		/* KEYF								*/

	uint16_t x ,y;
	uint16_t gx ,gy;

	/* CfbNXԍ`FbN		*/
	if ( !index && ( index > g_imageCount ) ) {
		return;
	}

	/* WNbsO				*/
	if ( lcdRectClip( &x1 ,&y1 ,&x2 ,&y2 ) ) {
		return;
	}

	/* C[Wt@C擾		*/
	flashFs_readIndex( FL_IMG_START - 1 + index ,&imgInfo );

	/* WC						*/
	if ( ( x2 - x1 + 1 ) > imgInfo.width ) {
		x2 = x1 + imgInfo.width - 1;
	}

	if ( ( y2 - y1 + 1 ) > imgInfo.height ) {
		y2 = y1 + imgInfo.height - 1;
	}

	/* LCD\JnʒuZbg		*/
	lcdSetWindow( x1 ,y1 ,x2 );

	/* \C[W\Jnʒu		*/
	imgPos = 0L;
	imgPage = imgInfo.topPage;
	imgOffset = 0;

	/* mode == G_OPAQUE ̏ꍇ̏î܂ܕ\j	*/
	if ( mode == G_OPAQUE ) {

		for ( gy = 0 ,y = y1 ;( y <= y2 ) && ( gy < imgInfo.height ) ;y++ ) {

			flashContinuousArrayRead( imgPage ,imgOffset );
			for ( gx = 0 ,x = x1 ;( x <= x2 ) && ( gx < imgInfo.width ) ;x++ ) {
				LCD_DATA = flashReadBYTE();
				LCD_DATA = flashReadBYTE();
			}

			/* ̕\y[WԍvZ		*/
			imgPos += (uint32_t)imgInfo.bytesPerLine;
			imgPage = imgInfo.topPage + (uint16_t)( imgPos / 512L );
			imgOffset = (uint16_t)( imgPos % 512L );
		}

	} else {

		/* L[Fl				*/
		kc1 = (uint8_t)( color >> 8 );
		kc2 = (uint8_t)color;

		/* wiF擾				*/
		bgGetFlag = 0;
		if  ( mode & 0x80 ) {							/* BGKv?		*/
			if ( bgMode == G_BGMODE_COLOR ) {			/* PF[h?		*/
				bc1 = (uint8_t)( bgColor >> 8 );
				bc2 = (uint8_t)bgColor;
			} else {
				bgGetFlag = 1;
			}
		}

		/* BGC[W\Jnʒu	*/
		if ( bgGetFlag ) {
			bgPos = ( (uint32_t)y1 * (uint32_t)bgInfo.bytesPerLine ) + ( (uint32_t)x1 * 2L );
			bgPage = bgInfo.topPage + (uint16_t)( bgPos / 512L );
			bgOffset = (uint16_t)( bgPos % 512L );
		}

		for ( gy = 0 ,y = y1 ;( y <= y2 ) && ( gy < imgInfo.height ) ;y++ ,gy++ ) {

			/* BGC[W̃Cf[^擾	*/
			if ( bgGetFlag ) {
				flashContinuousArrayRead( bgPage ,bgOffset );
				flashReadBLOCK( bgImg ,bgInfo.bytesPerLine );
				bgPos += (uint32_t)bgInfo.bytesPerLine;
				bgPage = bgInfo.topPage + (uint16_t)( bgPos / 512L );
				bgOffset = (uint16_t)( bgPos % 512L );
				bgp = bgImg;
			}

			/* PC\[v			*/
			flashContinuousArrayRead( imgPage ,imgOffset );
			for ( gx = 0 ,x = x1 ;( x <= x2 ) && ( gx < imgInfo.width ) ;x++ ,gx++ ) {

				/* \C[WsNZ擾	*/
				ic1 = flashReadBYTE();
				ic2 = flashReadBYTE();

				/* wiC[WsNZ擾	*/
				if ( bgGetFlag ) {
					bc1 = *bgp++;
					bc2 = *bgp++;
				}

				/* SF𔼓\									*/
				if ( mode == G_HALF_ALL ) {
					rgb[0] = ( ( ic1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
					rgb[1] = ( ( ( ( ic1 << 3 ) & 0x3f ) | ( ic2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
					rgb[2] = ( ( ic2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					LCD_DATA = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
					LCD_DATA = ( ( rgb[1] << 5 ) | rgb[2] );

				/* w̃L[𓧖\ / ̑̐F̂܂ܕ\	*/
				} else if ( mode == G_TRANSPARENT ) {
					if ( ( kc1 == ic1 ) && ( kc2 == ic2 ) ) {
						LCD_DATA = bc1;
						LCD_DATA = bc2;
					} else {
						LCD_DATA = ic1;
						LCD_DATA = ic2;
					}

				/* w̃L[𓧖\ / ̑̐F𔼓\	*/
				} else {
					if ( ( kc1 == ic1 ) && ( kc2 == ic2 ) ) {
						LCD_DATA = bc1;
						LCD_DATA = bc2;
					} else {
						rgb[0] = ( ( ic1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( ic1 << 3 ) & 0x3f ) | ( ic2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( ic2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
						LCD_DATA = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
						LCD_DATA = ( ( rgb[1] << 5 ) | rgb[2] );
					}
				}
			}

			/* \C[W̎̃CʒuvZ	*/
			imgPos += imgInfo.bytesPerLine;
			imgPage = imgInfo.topPage + (uint16_t)( imgPos / 512L );
			imgOffset = (uint16_t)( imgPos % 512L );
		}
	}

	FLASH_DISABLE_CS();
}

/*****************************************************************************
*							wtHgŕ\
* FG_DRAWMODE  mode    `惂[h G_OPAQUE      ̂܂ܕ`
*                                      G_HALF_ALL    tHgEwi𔼓`
*                                      G_TRANSPARENT tHgʏ` / wi𓧖`
*                                      G_HALF        tHgʏ` / wi𔼓ŕ`
* 		uint8_t fontNum     tHgԍ(1`)
*       uint16_t  x         \JnXW
*		uint16_t  y         \JnYW
*       char     *str       \(S-JIS)
*       uint16_t fColor     \F
*		uint16_t bColor     wiF( mode == G_TRANSPARENT͖)
* ߒlFvoid
******************************************************************************/
void g_puts( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,char *str ,uint16_t fColor ,uint16_t bColor )
{
	g_puts_sub( mode ,fontNum ,x ,y ,NA ,0 ,str ,fColor ,bColor );
}

void g_puts_P( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,const prog_char *str ,uint16_t fColor ,uint16_t bColor )
{
	char buf[512];
	strcpy_P( buf ,str );
	g_puts_sub( mode ,fontNum ,x ,y ,NA ,0 ,buf ,fColor ,bColor );
}

/*****************************************************************************
*						XN[\
* FG_DRAWMODE  mode  `惂[h G_OPAQUE      ̂܂ܕ`
*                                    G_HALF_ALL    tHgEwi𔼓`
*                                    G_TRANSPARENT tHgʏ` / wi𓧖`
*                                    G_HALF        tHgʏ` / wi𔼓ŕ`
*       uint8_t fontNum    tHgԍ(1`)
*		G_SCROLL *sp   	   XN[p[^\
*		uint16_t x            \JnXW
*		uint16_t y            \JnYW
*		uint16_t xclip        E[XW
*		char     *str      \
*       uint16_t fColor    \F
*		uint16_t bColor    wiF
* ߒlFvoid
*	g_scrollNext()֐ĂԑOɖ{֐ŃXN[̏Kv
*   *str / *sp ̓XN[rŔjȂlɂĂ
*****************************************************************************/
void g_scrollFirst( G_DRAWMODE mode ,uint8_t fontNum ,G_SCROLL *sp ,uint16_t x ,uint16_t y ,uint16_t xclip ,char *str ,uint16_t fColor ,uint16_t bColor )
{
	FONT *font;

	/* \					*/
	if ( g_puts_sub( mode ,fontNum ,x ,y ,xclip ,0 ,str ,fColor ,bColor ) == 0 ) {
		memset( sp ,0x00 ,sizeof(G_SCROLL) );

	} else {
		sp->enable = 1;
		sp->fontNum = fontNum;
		sp->s = str;
		sp->ss = str;
		sp->xposOffset = 0;
		sp->mode = mode;
		sp->fontColor = fColor;
		sp->bgColor = bColor;
		sp->x1 = x;
		sp->x2 = xclip;
		sp->x = x;
		sp->y = y;
		sp->code = getCharCode( &str );
		font = font_getImage( fontNum ,sp->code ,NULL );
		sp->fontWidth = font->xsize;
	}
}

/*****************************************************************************
*						XN[\
* FG_SCROLL *sp   	  XN[p[^\
* ߒlFvoid
*****************************************************************************/
void g_scrollNext( G_SCROLL *sp )
{
	char *s;
	FONT *font;

	if ( sp->enable ) {

		/* \ItZbgE擪|C^vZ	*/
		if ( sp->x == sp->x1 ) {
			sp->xposOffset++;
			if ( ( sp->xposOffset % sp->fontWidth ) == 0 ) {
				getCharCode( &sp->ss );				/* |C^i߂	*/
				s = sp->ss;
				sp->code = getCharCode( &s );
				sp->xposOffset = 0;
				if ( sp->code != 0 ) {
					font = font_getImage( sp->fontNum ,sp->code ,NULL );
					sp->fontWidth = font->xsize;
				}
			}
		} else {
			sp->x--;
		}

		/* \				*/
		if ( sp->code != 0x0000 ) {
			g_puts_sub( sp->mode ,sp->fontNum ,sp->x ,sp->y ,sp->x2 ,sp->xposOffset ,sp->ss ,sp->fontColor ,sp->bgColor );

		/* ̐擪ɖ߂		*/
		} else {
			g_puts_sub( sp->mode ,sp->fontNum ,sp->x ,sp->y ,sp->x2 ,0 ,"" ,sp->fontColor ,sp->bgColor );
			s = sp->s;
			sp->code = getCharCode( &s );
			font = font_getImage( sp->fontNum ,sp->code ,NULL );
			sp->fontWidth = font->xsize;
			sp->ss = sp->s;
			sp->xposOffset = 0;
			sp->x = sp->x2;
			g_puts_sub( sp->mode ,sp->fontNum ,sp->x ,sp->y ,sp->x2 ,0 ,sp->ss ,sp->fontColor ,sp->bgColor );
		}
	}



}

/*****************************************************************************
*					VS1053b`f[^e[uɂXyAi\
* Fuint16_t *dat XyAif[^l
*		G_DRAWMODE  mode  `惂[h G_OPAQUE      XyNgʏ`^wi`
*                                    G_HALF_ALL    XyNg𔼓`^wi𔼓`
*                                    G_TRANSPARENT XyNgʏ`^wi[`
*                                    G_HALF        XyNg𔼓`^wi[`
*		uint16_t       x     \̈`XW
*		uint16_t       y     \̈`YW
* ߒlFvoid
*****************************************************************************/
void g_drawSpectrum( uint16_t *dat ,G_DRAWMODE  mode ,uint16_t x ,uint16_t y )
{
	/* XyNgFe[u(31)	*/
	static uint8_t colors[] = {
		0xf8,0x00 ,0xfa,0x24 ,0xfa,0xc5 ,0xfb,0x45 ,0xfb,0xc6 ,0xfc,0x46 ,0xfc,0xc6 ,0xfd,0x47 ,
		0xfd,0xc7 ,0xfe,0x47 ,0xfe,0xc8 ,0xff,0x48 ,0xff,0xc9 ,0xf7,0xc9 ,0xe7,0xaa ,0xdf,0x8b ,
		0xcf,0x6b ,0xc7,0x4c ,0xbf,0x4d ,0xb7,0x2d ,0xaf,0x0e ,0x9f,0x0f ,0x96,0xef ,0x8e,0xd0 ,
		0x86,0xd0 ,0x7e,0xb1 ,0x76,0xb2 ,0x76,0xb3 ,0x7e,0xd4 ,0x7e,0xf5 ,0x7f,0x16
	};

	uint8_t *p;

	uint32_t bgPos = 0L;
	uint16_t bgPage = 0;			/* wiBGC[WSPItbVʒu	*/
	uint16_t bgOffset = 0;

	uint8_t currentValue;
	uint8_t peakValue;
	uint16_t data;
	uint16_t wy;
	uint16_t wx;
	uint8_t rgb[3];
	uint8_t bc1 = 0 ,bc2 = 0;
	uint8_t ic1,ic2;

	/* F					*/
	const uint8_t kc1 = (uint8_t)( SP_BG_COLOR >> 8 );
	const uint8_t kc2 = (uint8_t)SP_BG_COLOR;

	/* wiF擾				*/
	uint8_t bgGetFlag = 0;
	if  ( mode & 0x80 ) {							/* BGKv?		*/
		if ( bgMode == G_BGMODE_COLOR ) {			/* PF[h?		*/
			bc1 = (uint8_t)( bgColor >> 8 );
			bc2 = (uint8_t)bgColor;
		} else {
			bgGetFlag = 1;
		}
	}

	uint8_t i = SP_COUNT;
	while ( i-- ) {
	
		/* XyAif[^			*/
		data = *dat++;
		currentValue = (uint8_t)( data & 0x1f );
		peakValue = (uint8_t)( ( data & 0x07c0 ) >> 6 );
		if ( currentValue > peakValue ) {
			currentValue = peakValue;
		}

		/* BGC[W\Jnʒu	*/
		if ( bgGetFlag ) {
			bgPos = ( (uint32_t)y * (uint32_t)bgInfo.bytesPerLine ) + ( (uint32_t)x * 2L );
			bgPage = bgInfo.topPage + (uint16_t)( bgPos / 512L );
			bgOffset = (uint16_t)( bgPos % 512L );
		}

		/* X\͈͐ݒ				*/
		lcdSetWindow( x ,y ,x + SP_WIDTH - 1 );
		
		wy = SP_HEIGHT;
		p = colors;
		while ( wy-- ) {

			/* BGC[WAhXݒ					*/
			if ( bgGetFlag ) {
				flashContinuousArrayRead( bgPage ,bgOffset );
			}

			/* OiFݒ				*/
			ic1 = *p++;
			ic2 = *p++;

			wx = SP_WIDTH;
			while ( wx-- ) {

				/* BGC[WsNZF擾			*/
				bc1 = flashReadBYTE();
				bc2 = flashReadBYTE();

				/* XyNgʏ\^wiwi[`	*/
				if ( mode == G_OPAQUE ) {
					if ( ( peakValue ) && ( wy == ( peakValue - 1 ) ) ) {		/* s[Nz[hF	*/
						LCD_DATA = 0xf8;
						LCD_DATA = 0x00;
					} else if ( ( currentValue == 0 ) || ( wy > ( currentValue - 1 ) ) ) {	/* wi	*/
						LCD_DATA = kc1;
						LCD_DATA = kc2;
					} else {													/* LF		*/
						LCD_DATA = ic1;
						LCD_DATA = ic2;
					}

				/* LFEwi𔼓`			*/
				} else {
					if ( ( peakValue ) && ( wy == ( peakValue - 1 ) ) ) {		/* s[Nz[hF	*/
						ic1 = 0xf8;
						ic2 = 0x00;
					} else if ( ( currentValue == 0 ) || ( wy > ( currentValue - 1 ) ) ) {	/* wi	*/
						ic1 = 0x00;
						ic2 = 0x00;
					}

					rgb[0] = ( ( ic1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
					rgb[1] = ( ( ( ( ic1 << 3 ) & 0x3f ) | ( ic2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
					rgb[2] = ( ( ic2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					LCD_DATA = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
					LCD_DATA = ( ( rgb[1] << 5 ) | rgb[2] );
				}
			}

			/* BG[h̃tbVAhXύX	*/
			if ( bgGetFlag ) {
				bgPos += (uint32_t)bgInfo.bytesPerLine;
				bgPage = bgInfo.topPage + (uint16_t)( bgPos / 512L );
				bgOffset = (uint16_t)( bgPos % 512L );
			}
		}

		x += ( SP_WIDTH + 1 );
	}
}

/*****************************************************************************
*						wtHgŕ\(Tu֐)
* FG_DRAWMODE  mode    `惂[h G_OPAQUE      ̂܂ܕ`
*                                      G_HALF_ALL    tHgEwi𔼓`
*                                      G_TRANSPARENT tHgʏ` / wi𓧖`
*                                      G_HALF        tHgʏ` / wi𔼓ŕ`
* 		uint8_t  fontNum    tHgԍ(1`)
*       uint16_t    x          \JnXW
*		uint16_t    y          \JnYW
*		uint16_t    xclip	    E[XW
*		uint8_t  xposOffset \ItZbgl
*       char     *str       \(S-JIS)
*       uint16_t fColor     \F
*		uint16_t bColor     wiF( mode == G_TRANSPARENT͖)
* ߒlFuint8_t             0:S\ł  !0:\Ȃ
*****************************************************************************/
static uint8_t g_puts_sub( G_DRAWMODE mode ,uint8_t fontNum ,uint16_t x ,uint16_t y ,uint16_t xclip ,uint8_t xposOffset ,char *str ,uint16_t fColor ,uint16_t bColor )
{
	uint16_t x2 = 0 ,y2 = 0;
	uint16_t dx = 0 ,dy = 0;
	uint16_t cx = 0 ,cy = 0;
	uint8_t *p1 = NULL;
	uint8_t *p2 = NULL;
	uint8_t bitCount = 0;
	uint8_t bitData = 0;
	uint8_t bgGetFlag;
	uint8_t fc1 ,fc2;								/* tHgF				*/
	uint8_t bc1 = 0 ,bc2 = 0;						/* BGsNZF				*/
	uint8_t kc1 ,kc2;								/* wiF					*/
	uint8_t xposOffsetByte = 0;						/* tHgr`p		*/
	uint8_t xposOffsetBit = 0;
	uint32_t bgPos = 0L;							/* BGC[W擾p			*/
	uint16_t bgPage = 0;
	uint16_t bgOffset = 0;
	uint16_t code = 0;								/* R[h				*/
	uint8_t fontDatas[ FONT_DATA_MAX_LENGTH ];		/* tHgC[W			*/
	FONT *font = NULL;								/* tHg				*/
	uint8_t ret;
	uint8_t rgb[3];
	char *s;

	/* W`FbN							*/
	if ( xclip == NA ) {
		cx = DISPLAY_WIDTH - 1;
	} else {
		cx = xclip;
	}

	cy = DISPLAY_HEIGHT - 1;

	if ( ( x > cx ) || ( y > cy ) ) {	/* \͈͊O?	*/
		return ( 0 );
	}

	/* tHg\F擾						*/
	fc1 = (uint8_t)( fColor >> 8 );
	fc2 = (uint8_t)fColor;

	/* wi\F擾							*/
	kc1 = (uint8_t)( bColor >> 8 );
	kc2 = (uint8_t)bColor;

	/* BGF擾									*/
	bgGetFlag = 0;
	if  ( mode & 0x80 ) {					/* BGKv?				*/
		if ( bgMode == G_BGMODE_COLOR ) {	/* PFBG[h?			*/
			bc1 = (uint8_t)( bgColor >> 8 );
			bc2 = (uint8_t)bgColor;
		} else {
			bgGetFlag = 1;
		}
	}

	/* tHg\ItZbgl						*/
	if ( xposOffset != 0 ) {
		xposOffsetByte = xposOffset / 8;
		xposOffsetBit = xposOffset % 8;
	}

	/* \[v								*/	
	s = str;
	ret = 1;
	code = 0xffff;
	while ( x <= cx ) {

		/* ݈ʒu當R[hPo		*/
		/* tHgf[^擾					*/
		if ( code ) {
			code = getCharCode( &s );
			if ( code == 0x0000 ) {
				ret = 0;
				if ( xclip == NA ) {
					break;
				}
				font = font_getImage( fontNum ,0x20 ,fontDatas );
			} else {
				font = font_getImage( fontNum ,code ,fontDatas );
			}
		}

		/* \̈ݒ							*/
		x2 = x + font->xsize - 1;
		y2 = y + font->ysize - 1;
		if ( x2 > cx ) x2 = cx;
		if ( y2 > cy ) y2 = cy;
		dx = x2 - x + 1;
		dy = y2 - y + 1;
		x2 -= xposOffset;

		/* LCD\JnʒuZbg		*/
		lcdSetWindow( x ,y ,x2 );

		/* BGC[W擪tbVAhXvZ	*/
		if ( bgGetFlag ) {
			bgPos = ( (uint32_t)y * (uint32_t)bgInfo.bytesPerLine ) + (uint32_t)( x * 2 );
			bgPage = bgInfo.topPage + (uint16_t)( bgPos / 512L );
			bgOffset = (uint16_t)( bgPos % 512L );
		}

		p1 = fontDatas;
		while ( dy-- ) {
		
			/* BGC[WAhXݒ					*/
			if ( bgGetFlag ) {
				flashContinuousArrayRead( bgPage ,bgOffset );
			}

			/* ItZbg\L莞̏			*/
			p2 = p1;
			if ( xposOffset != 0 ) {
				if ( xposOffsetByte != 0 ) {
					p2 += xposOffsetByte;
				}

				if ( xposOffsetBit != 0) {
					 bitData = *p2++;
					 bitData <<= xposOffsetBit;
				}
			}

			for ( bitCount = xposOffset ;bitCount < dx ;bitCount++ ) {

				/* tHgf[^1oCgo		*/
				if ( ( bitCount % 8 ) == 0 ) {
					 bitData = *p2++;
				}

				/* BGC[Wf[^擾					*/
				if ( bgGetFlag ) {
					bc1 = flashReadBYTE();
					bc2 = flashReadBYTE();
				}

				/* ʏ\							*/
				if ( mode == G_OPAQUE ) {
					if ( bitData & 0x80 ) {
						LCD_DATA = fc1;
						LCD_DATA = fc2;
					} else {
						LCD_DATA = kc1;
						LCD_DATA = kc2;
					}

				/* tHgEwi𔼓`		*/
				} else if ( mode == G_HALF_ALL ) {
					if ( bitData & 0x80 ) {
						rgb[0] = ( ( fc1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( fc1 << 3 ) & 0x3f ) | ( fc2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( fc2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					} else {
						rgb[0] = ( ( kc1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( kc1 << 3 ) & 0x3f ) | ( kc2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( kc2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
					}
					LCD_DATA = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
					LCD_DATA = ( ( rgb[1] << 5 ) | rgb[2] );

				/* G_TRANSPARENT tHgʏ` / wi𓧖`	*/
				} else if ( mode == G_TRANSPARENT ) {
					if ( bitData & 0x80 ) {
						LCD_DATA = fc1;
						LCD_DATA = fc2;
					} else {
						LCD_DATA = bc1;
						LCD_DATA = bc2;
					}

				/* tHgʏ` / wi𔼓ŕ`				*/
				} else {
					if ( bitData & 0x80 ) {
						LCD_DATA = fc1;
						LCD_DATA = fc2;
					} else {
						rgb[0] = ( ( kc1 >> 3 ) + ( bc1 >> 3 ) ) / 2;
						rgb[1] = ( ( ( ( kc1 << 3 ) & 0x3f ) | ( kc2 >> 5 ) ) + ( ( ( bc1 << 3 ) & 0x3f ) | ( bc2 >> 5 ) ) ) / 2;
						rgb[2] = ( ( kc2 & 0x1f ) + ( bc2 & 0x1f ) ) / 2;
						LCD_DATA = ( ( rgb[0] << 3 ) | ( rgb[1] >> 3 ) );
						LCD_DATA = ( ( rgb[1] << 5 ) | rgb[2] );
					}
				}

				bitData <<= 1;
			}

			/* tHgf[^̎̍s						*/
			p1 += font->linePerBytes;

			/* BG[h̃tbVAhXύX	*/
			if ( bgGetFlag ) {
				bgPos += (uint32_t)bgInfo.bytesPerLine;
				bgPage = bgInfo.topPage + (uint16_t)( bgPos / 512L );
				bgOffset = (uint16_t)( bgPos % 512L );
			}
		}

		x += ( dx - xposOffset );
		xposOffset = 0;
	}

	return ( ret );
}
