/*###########################################################################
#                                                                           #
#                           VXeW[                              #
#                                                                           #
###########################################################################*/
#define __SYSTEM_C__
#include "project.h"

/* O[oϐ`			*/
extern FATFS fs;

/* [Jϐ`			*/
static const prog_char INI_FILE_NAME[] = "SYSTEM.INI";
static uint16_t cx = 0 ,cy = 0 ,y = 0;

/* [J֐vg^Cv錾	*/
static uint8_t load_files( FIL *fl );
static char *getIniFileItem( uint16_t lineCount ,uint16_t index ,uint16_t nMax ,char *txt ,const prog_char *name ,uint16_t *n );
static void disp_progress( uint16_t val ,uint16_t max );
static void disp_flashFree( void );

/*****************************************************************************
*							VXe
* Fvoid
* ߒlFvoid
* G[̓bZ[W\܂ܖ[v
*****************************************************************************/
void system_init( void )
{
	FIL fl;
	char fname[ sizeof(INI_FILE_NAME) ];

	strcpy_P( fname ,INI_FILE_NAME );

	/* tbVt@CVXe	*/
#if FORMAT
	flashFs_format();
#endif

	if ( flashFs_checkSystem() != 0 ) {
		if ( flashFs_format() != 0 ) {
			lcdPuts_P( 0 ,16 ,PSTR("serial flash file system format error !!") ,RGB( 255 ,0 ,0 ) );
			while ( 1 );
		}
	}
	disp_flashFree();

	/* uSYSTEM.INIv				*/
	f_mount( 0 ,&fs );
	if ( f_open( &fl ,(const TCHAR *)fname ,FA_READ ) == FR_OK ) {
		if ( load_files( &fl ) != 0 ) {
			f_close( &fl );
			while ( 1 );
		}
		f_close( &fl );
	}

	/* C[Wێ				*/
	g_images_init();

	/* UNICODEϊe[u		*/
	if ( unicode_init() != 0 ) {
		lcdPuts_P( 0 ,28 ,PSTR("The UNICODE table is not installed.") ,RGB( 255 ,0 ,0 ) );
		while ( 1 );
	}

	/* tHg					*/
	if ( font_init() != 0 ) {
		lcdPuts_P( 0 ,28 ,PSTR("The font memory cannot be secured.") ,RGB( 255 ,0 ,0 ) );
		while ( 1 );
	}

	if ( font_count() == 0 ) {
		lcdPuts_P( 0 ,28 ,PSTR("The font is not installed.") ,RGB( 255 ,0 ,0 ) );
		while ( 1 );
	}
}

/*****************************************************************************
*		uSYSTEM.INIvt@CɋLqĂet@C[h
* FFIL *fl FatFst@C\
* ߒlFuint8_t 0:OK !0:NG
*****************************************************************************/
static uint8_t load_files( FIL *fl )
{
	const prog_char *sections[] = { PSTR("[FONTS]") ,PSTR("[UNICODE]") ,PSTR("[BG]") ,PSTR("[IMAGE]") ,NULL };

	char buf[128];
	char msg[128];

	char *p1 ,*p2;
	uint16_t n;
	FONT h_font;
	FONT z_font;
	FILINFO fi;
	uint16_t lineCount = 0;
	uint16_t index;
	uint16_t fsIndex;
	uint8_t ret;
	uint8_t i;
	uint8_t sectionType = 0;
	uint8_t sectionFlag = 0;
	uint8_t uniFlag = 0;

	index = 0;
	while ( !f_eof( fl ) ) {
		y = 32;

		/* 1s擾							*/
		if ( f_gets( buf ,sizeof(buf) ,fl ) == NULL ) {
			sprintf_P( msg ,PSTR("#%d : file read error") ,lineCount );
			lcdPuts( 0 ,28 ,msg ,RGB( 255 ,0 ,0 ) );
			return ( 2 );
		}
		lineCount++;

		/* ̉sR[h폜			*/
		while ( ( p1 = strchr( buf ,'\r' ) ) != NULL ) {
			*p1 = '\0';
		}
		strtrim( buf );

		/* Rgs/󔒍sXLbv		*/
		if ( ( buf[0] == '#' ) || ( buf[0] == '\0' ) ) {
			continue;
		}

		/* eZNVo					*/
		for ( i = 0 ;sections[ i ] != NULL ;i++ ) {
			if ( strcasecmp_P( buf ,sections[i] ) == 0 ) {
				if ( sectionFlag & _BV(i) ) {
					sprintf_P( msg ,PSTR("#%d : There are two or more sections.") ,lineCount );
					lcdPuts( 0 ,28 ,msg ,RGB( 255 ,0 ,0 ) );
					return ( 2 );
				}
				sectionFlag |= _BV(i);
				sectionType = ( i + 1 );
				index = 0;
				break;
			}
		}

		if ( sections[i] != NULL ) {
			continue;
		}

		index++;
		g_boxF( G_OPAQUE ,0 ,y ,DISPLAY_WIDTH - 1 ,y + 18 ,lcdGetBgColor() );

		/*									*/
		/* tHgZNV			*/
		/*									*/
		if ( sectionType == 1 ) {
			p1 = getIniFileItem( lineCount ,index ,FONT_COUNT_MAX ,buf ,PSTR("FONT") ,&n );
			if ( p1 == NULL ) {
				return ( 3 );
			}

			p2 = strstr_P( p1 ,PSTR(";") );
			if ( p2 <= p1 ) {
				sprintf_P( msg ,PSTR("#%d : There is no semicolon.") ,lineCount );
				lcdPuts( 0 ,28 ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 4 );
			}
			*p2++ = '\0';

			if ( *p2 == '\0' ) {
				printf_P( msg ,PSTR("#%d : The font name is insufficient.") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 5 );
			}

			/* ptHgǍ			*/
			sprintf_P( msg ,PSTR("Font%d [%s] ... ") ,index ,getFileName( p1 ) );
			lcdPuts( 0 ,y ,msg ,RGB( 255 ,255 ,255 ) );
			cy = y;
			cx = strlen( msg ) * 6;
			y += 12;

			fsIndex = FL_FONT_START + ( ( index - 1 ) * 2 );
			ret = flashFs_loadFile( 0 ,fsIndex + 0 ,p1 ,FLASH_FS_FILE ,AUTO_RESERV ,disp_progress );
			if ( ret ) {
				sprintf_P( msg ,PSTR("#%d : File load error %d") ,lineCount ,ret );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				flashFs_format();
				return ( 6 );
			}

			ret = font_getInfo( fsIndex + 0 ,&h_font );
			if ( ret ) {
				sprintf_P( msg ,PSTR("#%d :It is not FONT decussate type.(%d)") ,lineCount ,ret );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 7 );
			}

			if ( h_font.codeType != 0 ) {
				sprintf_P( msg ,PSTR("#%d : It is not a ANK font.") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 8 );
			}

			/* SptHgǍ			*/
			sprintf_P( msg ,PSTR("      [%s] ... ") ,getFileName( p2 ) );
			lcdPuts( 0 ,y ,msg ,RGB( 255 ,255 ,255 ) );
			cy = y;
			cx = strlen( msg ) * 6;
			y += 12;

			ret = flashFs_loadFile( 0 ,fsIndex + 1 ,p2 ,FLASH_FS_FILE ,AUTO_RESERV ,disp_progress );
			if ( ret ) {
				sprintf_P( msg ,PSTR("#%d : File load error %d") ,lineCount ,ret );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				flashFs_format();
				return ( 9 );
			}

			ret = font_getInfo( fsIndex + 1 ,&z_font );
			if ( ret ) {
				sprintf_P( msg ,PSTR("#%d :It is not FONT decussate type.(%d)") ,lineCount ,ret );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 10 );
			}

			if ( z_font.codeType != 1 ) {
				sprintf_P( msg ,PSTR("#%d : It is not a KANJI font.") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 11 );
			}

			/* tHgTCY`FbN	*/
			if ( h_font.ysize != z_font.ysize ) {
				sprintf_P( msg ,PSTR("#%d : The height of the font is different.") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 12 );
			}

			if ( h_font.xsize * 2 != z_font.xsize ) {
				sprintf_P( msg ,PSTR("#%d : The width of ANK and KANJI is not 1:2") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 13 );
			}

		/*									*/
		/* jR[hZNV			*/
		/*									*/
		} else if ( sectionType == 2 ) {
			if ( ( p1 = getIniFileItem( lineCount ,0 ,0 ,buf ,PSTR("UNICODE2SJIS") ,&n ) ) != NULL ) {
				if ( uniFlag & 0x01 ) {
					sprintf_P( msg ,PSTR("#%d : UNICODE2SJIS is double item.") ,lineCount );
					lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
					return ( 14 );
				}
				uniFlag |= 0x01;
				fsIndex = FL_UNI2SJIS;

			} else if ( ( p1 = getIniFileItem( lineCount ,0 ,0 ,buf ,PSTR("SJIS2UNICODE") ,&n ) ) != NULL ) {
				if ( uniFlag & 0x02 ) {
					sprintf_P( msg ,PSTR("#%d : SJIS2UNICODE is double item.") ,lineCount );
					lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
					return ( 15 );
				}
				uniFlag |= 0x02;
				fsIndex = FL_SJIS2UNI;

			} else {
				sprintf_P( msg ,PSTR("#%d : The item name is wrong.") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 16 );
			}

			if ( f_stat( (const TCHAR *)p1 ,&fi ) != FR_OK ) {
				sprintf_P( msg ,PSTR("#%d : File info read error.") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 17 );
			}

			if ( fi.fsize != 131072L ) {
				sprintf_P( msg ,PSTR("#%d : File size error.") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( 18 );
			}

			sprintf_P( msg ,PSTR("UNICODE [%s] ... ") ,getFileName( p1 ) );
			lcdPuts( 0 ,y ,msg ,RGB( 255 ,255 ,255 ) );
			cy = y;
			cx = strlen( msg ) * 6;
			y += 12;

			ret = flashFs_loadFile( 0 ,fsIndex ,p1 ,FLASH_FS_FILE ,AUTO_RESERV ,disp_progress );
			if ( ret ) {
				sprintf_P( msg ,PSTR("#%d : File load error %d") ,lineCount ,ret );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				flashFs_format();
				return ( 19 );
			}

		/*									*/
		/* BG(wiC[W)ZNV	*/
		/*									*/
		} else if ( sectionType == 3 ) {
			p1 = getIniFileItem( lineCount ,index ,FONT_COUNT_MAX ,buf ,PSTR("BG") ,&n );
			if ( p1 == NULL ) {
				return ( 20 );
			}

			sprintf_P( msg ,PSTR("BG%d [%s] ... ") ,n ,getFileName( p1 ) );
			lcdPuts( 0 ,y ,msg ,RGB( 255 ,255 ,255 ) );
			cy = y;
			cx = strlen( msg ) * 6;
			y += 12;

			ret = flashFs_loadFile( 0 ,FL_BG_START + n - 1 ,p1 ,FLASH_FS_IMAGE ,300 ,disp_progress );
			if ( ret ) {
				sprintf_P( msg ,PSTR("#%d : File load error %d") ,lineCount ,ret );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				flashFs_format();
				return ( 21 );
			}

		/*									*/
		/* C[WZNV			*/
		/*									*/
		} else if ( sectionType == 4 ) {
			p1 = getIniFileItem( lineCount ,0xffff ,IMAGE_MAX ,buf ,PSTR("IMG") ,&n );
			if ( p1 == NULL ) {
				return ( 22 );
			}

			sprintf_P( msg ,PSTR("IMG%d [%s] ... ") ,n ,getFileName( p1 ) );
			lcdPuts( 0 ,y ,msg ,RGB( 255 ,255 ,255 ) );
			cy = y;
			cx = strlen( msg ) * 6;
			y += 12;

			ret = flashFs_loadFile( 0 ,FL_IMG_START + n - 1 ,p1 ,FLASH_FS_IMAGE ,AUTO_RESERV ,disp_progress );
			if ( ret ) {
				sprintf_P( msg ,PSTR("#%d : File load error %d") ,lineCount ,ret );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				flashFs_format();
				return ( 23 );
			}
		}

		disp_flashFree();
	}

	return ( 0 );
}

/*****************************************************************************
*						ACé`FbN
* Fuint16_t lineCount    sԍ
*		uint16_t index        ҂Yԍ(0xffff:Aԃ`FbN)
*		uint16_t nMax         Yől
*		char *txt             ͕
*       const prog_char *name ACe
*		uint16_t *n           ACeY
* ߒlFchar *                ACelJn|C^(NULL:error)
*****************************************************************************/
static char *getIniFileItem( uint16_t lineCount ,uint16_t index ,uint16_t nMax ,char *txt ,const prog_char *name ,uint16_t *n )
{
	char *p1 ,*p2;
	uint16_t len;
	char msg[64];

	(*n) = 0;

	/* ACe`FbN		*/
	if ( strcasestr_P( txt ,name ) != txt ) {
		if ( index || nMax ) {
			sprintf_P( msg ,PSTR("#%d : error1") ,lineCount );
			lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
		}
		return ( NULL );
	}
	p1 = &txt[ strlen_P( name ) ];

	/* '=' o					*/
	p2 = strchr( p1 ,'=' );
	if ( p2 < p1 ) {
		sprintf_P( msg ,PSTR("#%d : error2") ,lineCount );
		lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
		return ( NULL );
	}
	*p2++ = '\0';

	/* Y`FbN			*/
	if ( index ) {
		len = strlen( p1 );
		if ( len ) {
			if ( !isDecimalNumberString( p1 ) ) {		/* Ył͂ȂH	*/
				sprintf_P( msg ,PSTR("#%d : error3") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( NULL );
			}

			if ( len > 4 ) {							/* Y4𒴂ĂH	*/
				sprintf_P( msg ,PSTR("#%d : error4") ,lineCount );
				lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
				return ( NULL );
			}
		}

		(*n) = atoi( p1 );
		if ( *n > nMax ) {								/* ől𒴂ĂH			*/
			sprintf_P( msg ,PSTR("#%d : error5") ,lineCount );
			lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
			return ( NULL );

		} else if ( *n == 0 ) {							/* ȗ܂0w肳ĂH*/
			sprintf_P( msg ,PSTR("#%d : error6") ,lineCount );
			lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
			return ( NULL );

		} else if ( ( index != 0xffff )  && ( *n != index ) ) {		/* AԎwł͂ȂH*/
			sprintf_P( msg ,PSTR("#%d : error7") ,lineCount );
			lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
			return ( NULL );
		}

	}

	if ( *p2 == '\0' ) {								/* ACe̒lH			*/
		sprintf_P( msg ,PSTR("#%d : error8") ,lineCount );
		lcdPuts( 0 ,y ,msg ,RGB( 255 ,0 ,0 ) );
		return ( NULL );
	}

	return ( p2 );
}

/*****************************************************************************
*								i\
* Fuint16_t val il
*       uint16_t max ől
* ߒlFvoid
*****************************************************************************/
static void disp_progress( uint16_t val ,uint16_t max )
{
	char buf[8];
	sprintf_P( buf ,PSTR("%3d%%") ,(uint16_t)( ( (uint32_t)val * 100L ) / (uint32_t)max ) );
	lcdPuts( cx ,cy ,buf ,RGB( 255 ,255 ,0 ) );
}

/*****************************************************************************
*							VAtbV󂫗eʕ\
* Fvoid
* ߒlFvoid
*****************************************************************************/
static void disp_flashFree( void )
{
	char buf[50];
	sprintf_P( buf ,PSTR("flash file system free %4u block") ,flashFs_getFreeBlockCount() );
	lcdPuts( 0 ,16 ,buf ,RGB( 0 ,255 ,255 ) );
}

