/*###########################################################################
#                                                                           #
#						UNICODE -> SJIS ϊ֐Q							#
#                                                                           #
###########################################################################*/
#ifndef __UNICODE_H__
#define __UNICODE_H__

#include <avr/io.h>
#include "FatFs/integer.h"

/* ee[ũtbVt@CCfbNX`	*/
#define FL_UNI2SJIS 0				/* UNI2SJIS.BIN : UNICODE -> SJISϊ		*/
#define FL_SJIS2UNI 1				/* SJIS2UNI.BIN : SJISE -> UNICODEϊ		*/

/*	S-JIS1oCgڃ`FbN	*/
#ifndef IS_SJIS1
#define IS_SJIS1(code) ( ( ( (uint8_t)(code) >= 0x81 ) && ( (uint8_t)(code) <= 0x9f ) ) || ( ( (uint8_t)(code) >= 0xe0 ) && ( (uint8_t)(code) <= 0xfc ) ) )
#endif

/*	S-JIS2oCgڃ`FbN	*/
#ifndef IS_SJIS2
#define IS_SJIS2(code) ( ( ( (uint8_t)(code) >= 0x40 ) && ( (uint8_t)(code) <= 0x7e ) ) || ( ( (uint8_t)(code) >= 0x80 ) && ( (uint8_t)(code) <= 0xfc ) ) )
#endif

/* R[h^Cv				*/
#define CODE_NONE    0						/* R[hʂł		*/
#define CODE_SJIS    1						/* S-JIS					*/
#define CODE_UTF16LE 2						/* UTF-16LE					*/
#define CODE_UTF16BE 3						/* UTF-16BE					*/
#define CODE_UTF8    4						/* UTF-8					*/

/* ϊvCIeB			*/
#define PR_UTF16_UTF8_SJIS	( CODE_UTF16LE | ( CODE_UTF16BE << 3 ) | ( CODE_UTF8    << 6 ) | ( CODE_SJIS    << 9 ) )
#define PR_UTF8_UTF16_SJIS  ( CODE_UTF8    | ( CODE_UTF16LE << 3 ) | ( CODE_UTF16BE << 6 ) | ( CODE_SJIS    << 9 ) )
#define PR_SJIS_UTF8_UTF16  ( CODE_SJIS    | ( CODE_UTF8    << 3 ) | ( CODE_UTF16LE << 6 ) | ( CODE_UTF16BE << 9 ) )
#define PR_UTF8_SJIS_UTF16  ( CODE_UTF8    | ( CODE_SJIS    << 3 ) | ( CODE_UTF16LE << 6 ) | ( CODE_UTF16BE << 9 ) )

/* ֐vg^Cv錾	*/
uint8_t unicode_init( void );
WCHAR ff_wtoupper( WCHAR chr );
WCHAR ff_convert( WCHAR src ,UINT dir );
uint8_t unicode_ConvSJIS( char *s ,uint16_t pr );

#endif
